typedef int    IntArr<>;
typedef float  FloatArr<>;
typedef double DoubleArr<>;
typedef u_long   LongArr<>;

typedef char   String<>;
typedef String StrArr<>;

typedef struct Table* TablePtr;

enum  LockStatusType 
{
    ALLOCATED = 0,
    FREE,
    FAILURE
};

/*
enum  ArchitectureType
{    
    UNKNOWN   = 500,
    SUN_SPARC,
    DEC_ALPHA,
    HP_UX,
    DECPC,
    DELLPC,

    END_OF_ARCH_TYPES
};
*/

struct Node
{
    int              NodeId;
    String           Name;
    String           IPaddress;
    String           ArchType;
    String           FileSys;
    int              Capacity;
    u_long           RangeBegin;
    u_long           RangeEnd;
};

typedef Node NodeArr<>;

struct Table
{
    Node     NodeInf;
    TablePtr Next;
};

struct MagicNumber
{
    float   hpf;
};

typedef MagicNumber MagicNumberArr<>;

struct Lock
{
    int          NodeId;
    int          LockId;
    MagicNumber  MagicNum;
};

typedef Lock LockArr<>;

struct LocalLock{
    Lock            LockInf;
    int             RibId;
    int             SeqNum;
    LockStatusType  Status;
    String          IPAddress;
} ;

typedef LocalLock LocalLockArr<>;

struct LockRequest {
    LockArr LockList;
    IntArr  Perm;
    int     NodeId;
    int     SeqNum;
};

struct RibInf
{
    int     NodeId;
    String  Directives;
    String  FuncName;
    StrArr  Files;
    int     Pid;
};



program COORDINATOR
{
    version INITIALIZE
    {

        NodeArr BROADCAST_SUBSCRIBE(StrArr)   = 1;
        int  BROADCAST_JOIN(Node )            = 2;
        void  BOOT_UP(int)                    = 3;
	int BROADCAST_SATTU(StrArr)	      = 4; /*added by sattu*/
    } = 1;

    version UNSUBSCRIBE
    {
        void BROADCAST_LEAVE(int )         = 1;
        void LEAVE_SYSTEM( void)           = 2;
    } = 2;

    version SERVER
    {
        u_long PROCESS_RIB(RibInf)          = 1;
        int  INIT_FILE_PTR(String)          = 2;
        int  PUT_IN_FILE( String )          = 3;
        int  CLOSE_FILE(String)             = 4;
        void CLEANUP( RibInf)               = 5;
        void REMOVE_FILES( RibInf)          = 6;
    } = 3;

    version GENERATOR
    {
       LockArr      REQUEST_LOCK_INFO(int )          = 1;
       LockRequest  ACQUIRE_LOCKS(LockRequest)       = 2;
      /* MagicNumber  CALCULATE_CUR_MAGICNUM( void)    = 3;*/
       MagicNumber  CALCULATE_CUR_MAGICNUM_VER2(void)= 3;
			/*	Added by Satish on 12/02/99	*/
    } = 4;

    version USER_INTERACTION
    {
        LocalLockArr GET_LOCKS_AVAILABLE( int)        = 1;
        u_long       POST_RIB_INF(RibInf)             = 2;
        void         RESULT_INTIMATION( LongArr)      = 3;
        void         ERROR_IN_EXECUTION( StrArr)      = 4;
        void         REGISTER_PROGRAM(int)            = 5;
        void         UNREGISTER_PROGRAM(int)          = 6;
        void         UNLOCK( LocalLockArr)            = 7;
    }  = 5;

    version ADMINISTRATION
    {
        void DEPOSIT_LOCKS( int)         = 1;
        void REMOVE_LOCKS( int)          = 2;
        void SET_LOCK_ALLOCATED(Lock)    = 3;
        void SET_LOCK_FREE( Lock)        = 4;
    } = 6;
    
    version NODE_FAILURE
    {
        void REGISTER_TIMER_PID(int)  = 1;
        void NODE_FAILED( int)        = 2;
        void BROADCAST_FAIL( int)     = 3;
    } = 7;
} = 0x33ffffff;
