#include <stdio.h>
#include "../commonIncludes/_defn.h"
#include "../commonIncludes/Coordinator.h"
//#include "Coordinator.h"
#include "_loadTable.h"
#include "Table.c"

// The purpose of this method is to collect all the information about the host-machine
// and store it in a array and return it.


StrArr* loadTable(char* filename) {
    FILE    *fptr;
    StrArr  *strArr;
    char    myIPaddr[100];
    char    machineName[100];
    char    ipAddr[100];
    char    archName[100];
    char    fileSystem [100];
    char    capacity [100];
    char    cpuId1[100];
    char    cpuId2[100];
    int     i;
    int     found;

	//If the file name has no been specified,
    if (filename == NULL) {
        filename = (char*) calloc(252, sizeof(char));
		strcpy(filename,INFO_FILE);
    }

    fptr = fopen( filename, "r");
    if(fptr == NULL) {
		printf("file not found .. : %s \n",filename);
		exit(1);
    }
    
	//Get the ip-address of the machine
    GetHostNameAndIPadd( NULL, myIPaddr);

    found = 0;
	
	//Scan the entries in the file.
    while ( (!feof(fptr)) && (!found) ) {
    
        fscanf( fptr, "%s", machineName);
        fscanf( fptr, "%s", ipAddr);
        fscanf( fptr, "%s", archName);
        fscanf( fptr, "%s", fileSystem);
        fscanf( fptr, "%s", capacity);
        fscanf( fptr, "%s", cpuId1);
        fscanf( fptr, "%s", cpuId2);
		
		// If there is entry in the file for this host-machine then exit the while loop.
        if( !strcmp(ipAddr , myIPaddr)) {
				found = 1;   //the entry for the machine was found in the file
		}	
    }

    if (!found) {
			printf("This machine (%s)is not allowed to take part in ARC\n",ipAddr);
			exit(1);
	}
	else {
		printf("This machine (%s) is allowed to take part in ARC\n",ipAddr);
	}
			
    if(found) {

        strArr = (StrArr *) malloc( sizeof( StrArr));

        strArr->StrArr_len = 7; //  7 entries in the file
        strArr->StrArr_val = (String *) malloc( strArr->StrArr_len * 
            sizeof(String));
    
		//Create a empty string array to store all the information read about the 
		//host-machine, read from the file.
        for( i = 0; i < strArr->StrArr_len; i++) {
        
            strArr->StrArr_val[i].String_len = 0;
            strArr->StrArr_val[i].String_val = NULL;
        }

		//Put the information in the string array.
        PutInString( &(strArr->StrArr_val[0]), machineName);
        PutInString( &(strArr->StrArr_val[1]), myIPaddr);
        PutInString( &(strArr->StrArr_val[2]), archName);
        PutInString( &(strArr->StrArr_val[3]), fileSystem);
        PutInString( &(strArr->StrArr_val[4]), capacity);
        PutInString( &(strArr->StrArr_val[5]), cpuId1);
        PutInString( &(strArr->StrArr_val[6]), cpuId2);

        fclose(fptr);
        return strArr;
    }
    fclose(fptr);
    printf("In loadTable.c: StringArr is returned with no information \n");
    return strArr;
}

// This main method has been written only for testing purposes. Hence it was commented after
// the testing was over.

/*
main()
{
    StrArr* strArr;
    int     i;

    strArr = loadTable(NULL);

    for( i = 0; i < strArr->StrArr_len; i++)
    {
        printf( "%s \n", strArr->StrArr_val[i].String_val);   
    }
}
*/
