#include <stdio.h>
#include <string.h>
#include <rpc/rpc.h>
#include <unistd.h>
#include <sys/param.h>
#include "../commonIncludes/Coordinator.h"
#include "../commonIncludes/_defn.h"
#include "../commonIncludes/_join.h"

int main(int argc, char* argv[]) {

     CLIENT           *cl;
     StrArr           *strArr;
     char             hostName[MAXHOSTNAMELEN];
     char             ipAddr[50];
     int              *lresult;
     int              i;
     char			  tmp[100];
	 int			  isFirstNode = 0;
	 int 			  NO_OF_RETRIES = 0;
	 int 			  MAX_RETRIES_ALLOWED=3;
	 Bool			  connection_created = false;
	 static struct timeval TIMEOUT = {2000,2000};

	/** Get the name of the host machine in the first argument (hostName) 
	*  and the ip-address in the second argument (ipAddr) 
	*/

    //GetHostNameAndIPadd( hostName, ipAddr); 
	gethostname(hostName,MAXHOSTNAMELEN);
	 
		/** whether this is the first node is decided by the command line
		 * argument. We can also decide whether it is the first node  by
		 * broadcasting and asking if any other nodes are present. But this
		 * takes a long time and there are some other problems so for the
		 * time being we decide first node by a command line argument. for
		 * starting the first server give command as boot first.
		 */

	if(argc > 1) {

		if( strcmp(argv[1] , FIRST_NODE_STRING) == 0 ) { 
			
			isFirstNode = 1;  // you know that you are first one from the command line parameter
		}
		else {
			printf("Illegal argument supplied \n ");
			return 	-1;
		}
	}

	else {
			isFirstNode = 0;  // you know that you are not the 
								// first one from the command line parameter
	}

	printf(" Preparing to START the server .........\n");
	 
	// Start the server.....
	//if ( system( "/usr/bin/ddd coordinator &" ) != 0 ) {
	if ( system( "coordinator &" ) != 0 ) {
		error("Major problem can't start the server");
		return 5;
	}

	printf(" Server STARTED ..............\n");
			
		//Make at most 3 atempts to create a client handle with the coordinator 
		//and wait for 1 second between each retry.
	//sleep(5);
	sleep(1);
	
	while ( (!connection_created) && (NO_OF_RETRIES < MAX_RETRIES_ALLOWED) ) {
		if ( (cl = clnt_create(hostName, COORDINATOR, INITIALIZE, "tcp") )
					                    == NULL) {
			NO_OF_RETRIES = NO_OF_RETRIES + 1;
			printf("Join process :Attempt to create a connection with the coordinator FAILED \n");
			sleep(1);
		}
		else {
			connection_created = true;
			printf("Join process : Attempt to create a connection with the coordinator SUCCESSFUL \n");
		}
	}

	if ( (!connection_created) || (NO_OF_RETRIES >= 3) ) {
			clnt_pcreateerror(hostName);
			printf("Killing Coordinator\n");
			system("killall -9 coordinator");
			printf("Join process : Could not create a client connection with the local
									coordinator");
			return CLIENT_CONNECTION_FAIL;
	}

	if (clnt_call(cl, BOOT_UP, (xdrproc_t)xdr_int, (char *)&( isFirstNode),
					(xdrproc_t)xdr_void, NULL, TIMEOUT) != RPC_SUCCESS) {
		 
		//If the RPC call to the local server has failed then
		//
		printf(" Join process: local coordinator failed in clnt_call\n"); 
		printf("Join process : The RPC call on to the local coordinator FAILED\n");
		clnt_perror(cl, hostName);
		exit(CLIENT_CONNECTION_FAIL);
	}
}
