#include <stdio.h>
#include <rpc/rpc.h>
#include <unistd.h>
#include <sys/param.h>
#include "../commonIncludes/_defn.h"
#include "../commonIncludes/Coordinator.h"

/*
    Boot strapping will initialize the data which is global for
    remote procedures.

    This is the client program which will call the co-ordinator at this
    node itself.
*/

int main(int argc, char* argv[]) {
     CLIENT           *cl;
     char             server[MAXHOSTNAMELEN];
     int              numOfLocks;  
     void*            dum;
	 static struct timeval TIMEOUT = {25, 0};

     if (gethostname(server, MAXHOSTNAMELEN)) {
        error("main: gethostname: couldn't get the name of host");
        error("main: Sorry can't boot up");
        return GET_HOST_NAME_FAIL;
     }
	 printf("The host name received is %s\n",server);

     if ((cl = clnt_create(server, COORDINATOR, UNSUBSCRIBE, "tcp"))
                                            == NULL) {
        clnt_pcreateerror(server);
        return CLIENT_CONNECTION_FAIL;
     }

	 if (clnt_call(cl, LEAVE_SYSTEM, xdr_void, NULL,
	 								xdr_void, NULL, TIMEOUT) != RPC_SUCCESS) {
		//If the RPC call to the local server has failed then
		clnt_perror(cl, server);
		exit(CLIENT_CONNECTION_FAIL);
	 } 
	 printf("The client call on the local coordinator successful \n");
	 system("killall -9 coordinator");
	 system("killall -9 monitor");
     clnt_destroy(cl);
}
