#include <sys/param.h>
#include <rpc/rpc.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/signal.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "Coordinator.h" 
#include "_Tsp_ver3_get_newpath.h" 
#include "../usr/include/arcGlob.h"

#define    ARC_get_newpath       0 

get_newpathArguments     get_newpathArgs; 
get_newpathResults       get_newpathRes; 

char* get_newpathDirectives = " ";

void PostArgs( int ribId) {
	CLIENT* cl;
	static struct timeval  timeout = {0, 0};

	if( Buffer[ribId].LockId >= 0) {
		printf("IP address = %s , pronum = %ld \n",lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val,Buffer[ribId].ProgNum);

		if ((cl = clnt_create(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val,
				(u_long)Buffer[ribId].ProgNum, 1, "tcp")) == NULL) {
			clnt_pcreateerror(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val);
			return;
		}
	}

	else {
		if ((cl = clnt_create(str.String_val, (u_long)Buffer[ribId].ProgNum,
				1, "tcp")) == NULL) {
			clnt_pcreateerror(str.String_val);
			return; 
		}
	}
	
	if( Buffer[ribId].FuncType == ARC_get_newpath) {
		get_newpathArgs = *( (get_newpathArguments *)Buffer[ribId].Arguments);
		clnt_call(cl,  SEND_0_TSP_VER3_GET_NEWPATH_ARGS, xdr_get_newpathArguments, (char *)&get_newpathArgs, 
				xdr_void, NULL, timeout);
		clnt_destroy(cl);
		return;
	}
}

void GetResults( int ribId, u_long prognum) {
	CLIENT* cl; 

	if( Buffer[ribId].LockId >= 0) {
		if ((cl = clnt_create(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val, 
				(u_long)prognum, 1, "tcp")) == NULL) {
			clnt_pcreateerror(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val); 
			return;
		}
	}

	else {
		if ((cl = clnt_create(str.String_val, (u_long)prognum, 1, 
				"tcp")) == NULL) {
			clnt_pcreateerror(str.String_val);
			return; 
		}
	}

	if( Buffer[ribId].FuncType == ARC_get_newpath) {
		if( Buffer[ribId].LockId >= 0) {

			if (clnt_call(cl,  GET_0_TSP_VER3_GET_NEWPATH_RESULT, xdr_void, NULL,
				xdr_get_newpathResults, (char *)&get_newpathRes, TIMEOUT) != RPC_SUCCESS) 
			{
				clnt_perror( cl, lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val);
				return;
			}
		}

		else {
			if (clnt_call(cl,  GET_0_TSP_VER3_GET_NEWPATH_RESULT, xdr_void, NULL, 
					xdr_get_newpathResults, (char *)&get_newpathRes, TIMEOUT) != RPC_SUCCESS) 
			{
				clnt_perror( cl, str.String_val); 
				return; 
			}
		}

		Buffer[ribId].Results = (char *) malloc( sizeof(get_newpathRes));
		memcpy( Buffer[ribId].Results, (char *)&get_newpathRes, sizeof( get_newpathRes)); 
		Buffer[ribId].Status = Available;
		clnt_destroy(cl);
		return;
	}
}

void Terminate( int ribId) {
	RibInf  ribInf; 
	CLIENT* cl;
	char    server[50];
	int     clntFlag = 1;
	static struct timeval  timeout = {0, 0};

		GetHostNameAndIPadd(NULL, server ); 
	if( Buffer[ribId].LockId == -1) {
		if ((cl = clnt_create(server, (u_long)Buffer[ribId].ProgNum, 
				1, "tcp")) == NULL) {
			clnt_pcreateerror(server);
			return;
		}
		if( Buffer[ribId].FuncType == ARC_get_newpath) 
		{
			clnt_call(cl,  KILL_0_TSP_VER3_GET_NEWPATH, xdr_void, NULL, xdr_void, 
				NULL, timeout); 
			clnt_destroy(cl); 
			Buffer[ribId].Status = Terminated; 
			return;
		}
	}

	else {
		if ((cl = clnt_create(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val,
				(u_long)Buffer[ribId].ProgNum, 1, "tcp")) == NULL)
		{
			clnt_pcreateerror(lockList->LocalLockArr_val[Buffer[ribId].LockId].IPAddress.String_val);
			return;
		}

		if( Buffer[ribId].FuncType == ARC_get_newpath) {
			clnt_call(cl,  KILL_0_TSP_VER3_GET_NEWPATH, xdr_void, NULL, xdr_void, 
				NULL, timeout); 
			clnt_destroy(cl);
		}
		Buffer[ribId].Status = Terminated; 
	}
}

int New_Partition (MagicNumberArr *LockArr, int N, int* grains,int nodeid) {
    float total_grain_val = 0;

    return (total_grain_val);
}

intArr local_get_newpath(intArr matrix) {
		int i;
    for (i=0; i< DIM; i++) 
	    matrix.intArr_val [i] = 3333;

	return matrix;
}


intArr get_newpath( 
			intArr matrix, 
			int grain_size ) {

    intArr tempResult;
	double total_user,total_real,total_sys;

	int i,j,k;

	tempResult.intArr_len = DIM;
    tempResult.intArr_val = (int *) malloc (sizeof(int) * DIM);

	 my_process_time(1,NULL,NULL,NULL);

	 for(k=0;k<tempResult.intArr_len;k++) {
		tempResult.intArr_val[k] = 1111;
	 }

	 my_process_time(2,NULL,NULL,NULL);
	 my_process_time(3,&total_user,&total_real,&total_sys);

	 return tempResult; 
}

int main(int argc, char *argv[]) {
	 int i,j,k;
	 double total_sys;
	 double total_user;
	 double total_real;

	 int     LocksRequired,LocksGot;
	 MagicNumberArr *Marr;
     MagicNumber *magicNum;

	 SYNC *Sync;

	 intArr ResultMain;
	 intArr tempResult;
	 intArr matrix;

	 int    pathlen=0;
	 int InitialPaths;
	 
	 char* server;

	 int done=0;
     int Ngrains=0;
     int Ncount=0;
	 int Nrib=0;
	 int RibPos=0;
	 int finished=0;

	 LocksRequired = atoi(argv[1]);
  
	 matrix.intArr_len = DIM * DIM ;
	 matrix.intArr_val = (int*) malloc ( sizeof(int) * DIM * DIM); 

	 tempResult.intArr_len = DIM + 2;
	 tempResult.intArr_val = (int*) malloc ( sizeof(int) * (DIM + 2) );

     server = (char *) malloc (sizeof(char) * 100);

	 ArcStartUp();
	 LocksGot = GetLocks( LocksRequired);

	 Sync = (SYNC *) malloc( LocksGot * sizeof(SYNC));

     InitialPaths=30;

	 for( i = 0 ; i < InitialPaths ; i++) {

		  ResultMain=local_get_newpath(matrix); 
	 }

	 //Continue posting to remote machines till all the paths are exhausted

	 my_process_time(1,NULL,NULL,NULL);

     Marr = GetCurMagicNums(LocksGot);

	 for( i = 0; i < LocksGot; i++) {
		SetParam(100, 0, i);

 		IncrCurLockId(); 
 		Sync[i].RibId = RibId; 
 		SetRibParam( RibId); 
		Buffer[RibId].Status = NotAvailable; 
		Buffer[RibId].LockId = GetCurLockId(); 
		strcpy( Buffer[RibId].FuncName , "_Tsp_ver3_get_newpath" ); 
		Buffer[RibId].FuncType  = ARC_get_newpath; 
		time(&Buffer[RibId].StartTime); 
		Buffer[RibId].RetriesMade = 0; 
		strcpy( Buffer[RibId].Directives, get_newpathDirectives); 
            
 		memcpy(&get_newpathArgs.RibId, &RibId, sizeof(int)); 
 		memcpy(&get_newpathArgs.Pid, &pid, sizeof(int));

	 	if( Buffer[RibId].LockId >= 0) {
 				lockList->LocalLockArr_val[Buffer[RibId].LockId].Status = ALLOCATED; 
 			lockList->LocalLockArr_val[Buffer[RibId].LockId].RibId= RibId;
 		}
 		memcpy(&get_newpathArgs.NodeName, &(str), sizeof(Str));
	 	Buffer[RibId].Arguments = (char *) malloc( sizeof(get_newpathArgs)); 
 		memcpy(Buffer[RibId].Arguments, (char *)&get_newpathArgs, sizeof( get_newpathArgs)); 
 		Buffer[RibId].ProgNum = PostRibServer(RibId, getpid());
 		sleep(3);
 		PostArgs( RibId);
 		RibId++;
	 }

	 i=0;
	 j=0;
	 while((!finished)) {

		Nrib=messageHandler(&ResultMain,sizeof(ResultMain));
		if(Nrib >= 0) {

			tempResult.intArr_len = ResultMain.intArr_len ;
			for(k=0;k<tempResult.intArr_len;k++)
		    	tempResult.intArr_val[k] = ResultMain.intArr_val[k];

		}

		if(Nrib <= RibId) {
				Terminate(Nrib);
				Cdata[Nrib].Status = 1;
		}

          Ncount = 0;
		 
		  for(j=0;j<RibId;j++) {
		  		Ncount+=Cdata[j].Status; 
          }

          if(Ncount == RibId)
		      finished = 1;

	 }// End of while 
	 my_process_time(2,NULL,NULL,NULL);
	 my_process_time(3,&total_user,&total_real,&total_sys);

	 UnLock();
	 ArcCleanUp();

	 printf("the best result is %d \n", tempResult.intArr_val[DIM+1]);
}
