#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

extern char  fileName[];
extern char *progName;

void
error(char* fmt, ...)
{
    va_list args;

    va_start(args, fmt);
    fprintf(stderr, "error: ");
    vfprintf(stderr, fmt, args);
    fprintf(stderr, "\n");
    va_end(args);
}

FILE*
efopen(char* file, char* mode)
{
    FILE* fptr;

    if ((fptr = fopen(file, mode)) == NULL)
    {
        error("  fopen : can't open file %s", file);
        exit(1);
    }
    return fptr;
}

bool
checkExtension(char* file, char* ext)
{
    int ind1 = strlen(file) - 1;
    int ind2 = strlen(ext) - 1;

    if (ind2 > ind1)
    {
        return false;
    }

    for (register int i = ind2; i >= 0; i--)
    {
        if ( ext[ i ] != file[ ind1-- ] )
        {
            return false;
        }
    }
    return true;
}

void
getExtension(char* dest, char* src, char* ext)
{
    int ind = strlen(src);

    while(src[ --ind ] != '.')
                  ;

    strncpy(dest, src, ind);
    dest[ ind ] = '\0';
    strcat(dest, ext);
}

void
putBlanks(FILE* fptr, int j)
{ 
    for(register int i = 0; i < j; i++)
    {
        fputc(' ', fptr);
    }
}

FILE*
moreInput(char** argv, int args)
{
    static int count = 1;
    FILE*  fptr = NULL;

    while ( count < args )
    {
        strcpy(fileName, argv[count++]);

        if (!checkExtension(fileName, ".arc"))
        {
            fprintf(stderr, "%s : %s : Incorrect file name extension\n",
                                       progName, fileName);
            putBlanks(stderr, strlen(progName) + strlen(fileName) + 6);
            fprintf(stderr, "<name>.arc expected\n");
            continue;
        }

        if ((fptr = fopen(fileName, "r")) == NULL)
        {
            fprintf(stderr, "%s : can't open file %s\n",
                                       progName, fileName);
            continue;
        }

        return fptr;
    }

    return NULL;
}

void
lowerStr(char* dest, char* src)
{
    int i = 0;
    while(src[i] != '\0')
    {
        dest[i] = tolower(src[i]);
        i++;
    }
    dest[i] = '\0';
}

void
upperStr(char* dest, char* src)
{
    int i = 0;
    while(src[i] != '\0')
    {
        dest[i] = toupper(src[i]);
        i++;
    }
    dest[i] = '\0';
}

bool
isBlank(char c)
{
    return (c == ' ' || c == '\t');
}

int
flatten(char* list[], char* sl, char sep)
{
    int i = 0;
    int j = 0;

    while(sl[i] != '\0')
    {
        char buff[ 218 ];
        int  k = 0;

        while(sl[i] != sep && sl[i] != '\0')
        {
            buff[ k++ ] = sl[i++];
        }
        buff[ k ] = '\0';

        list[ j ] = new char[ k + 1 ];
        strcpy(list[ j ], buff);
        j++;
        if (sl[i] == '\0')
        {
            break;
        }
        i++;
    }
    return j;
}
