%{
#include <stdio.h>
#include "extFuncDefn.h"
#include "extGlobal.h"
#include "parser.tab.h"

extern int   lineNo;
extern FILE* moreInput(void);

int  bCount;
void eatUpComment(void);

%}

ALPHANUM    [A-Za-z0-9_]
CHAR        [A-Za-z_]
SPACE       [ \t]
SPACEOL     [ \t\n]
STRING      {CHAR}{ALPHANUM}*
VSTRING     {ALPHANUM}+(\[{ALPHANUM}+\])*

%s HEADER ARCF RIBBODY FCALL SCALL

%%

"/*"                                    {  eatUpComment();  }
<HEADER>{SPACE}*\"[^"]*\"               {
                                           BEGIN 0;
                                           lineNo++;
                                           processHeader(yytext, false);
                                        }
<HEADER>{SPACE}*<[^>]*>                 {
                                           BEGIN 0;
                                           lineNo++;
                                           processHeader(yytext, true);
                                        }
"#include"                              {  BEGIN HEADER;      }
<ARCF,FCALL,SCALL>{SPACE}*              {  ; }
<ARCF,FCALL,SCALL>\n                    {  lineNo++; }
<ARCF>{STRING}                          {
                                           strcpy(yylval.string, yytext);
                                           return STRING;
                                        }
<ARCF>{VSTRING}                         {
                                           strcpy(yylval.string, yytext);
                                           return VSTRING;
                                        }
<ARCF,FCALL,SCALL>"("                   {  return '(';  }
<ARCF,FCALL,SCALL>","                   {  return ',';  }
<ARCF,FCALL,SCALL>")"                   {  return ')';  }
<ARCF>":"                               {  return ':';  }
<ARCF,FCALL,SCALL>";"                   {  BEGIN 0;  return ';';   }
<ARCF>"*"                               {  return '*';  }
<ARCF>"{"                               {
                                           BEGIN RIBBODY;
                                           bCount = 0;
                                           fprintf(serFP, "{");
                                           fprintf(cltFP, "{");
                                           return '{';
                                        }
SYNC/({SPACEOL}|\*)+{STRING}            {
                                           BEGIN ARCF;
                                           return SYNC;
                                        }
<RIBBODY>"{"                            {
                                           bCount++;
                                           fprintf(serFP, "{");
                                           fprintf(cltFP, "{");
                                        }
<RIBBODY>"}"                            {
                                           fprintf(serFP, "}");
                                           fprintf(cltFP, "}");
                                           if (bCount-- <= 0)
                                           {
                                               BEGIN  0;
                                               return '}';
                                           }
                                        }
<RIBBODY>.|\n                           {
                                           fprintf(serFP, "%s", yytext);
                                           fprintf(cltFP, "%s", yytext);
                                           fflush(serFP);
                                        }
<FCALL,SCALL>{STRING}                   {
                                           strcpy(yylval.string, yytext);
                                           return STRING;
                                        }
<FCALL,SCALL>{VSTRING}                  {
                                           strcpy(yylval.string, yytext);
                                           return VSTRING;
                                        }
<FCALL>":="                             {  return EQ;     }
<FCALL,SCALL>"&"                        {  return '&';    }
SYNC/{SPACEOL}*"("                      {  BEGIN SCALL; return SYNC;   }
SYNCAND/{SPACEOL}*"("                   {  BEGIN SCALL; return SYNCAND; }
SYNCOR/{SPACEOL}*"("                    {  BEGIN SCALL; return SYNCOR;  }
SYNCALL/{SPACEOL}*"("                   {  BEGIN SCALL; return SYNCALL; }
SYNCANY/{SPACEOL}*"("                   {  BEGIN SCALL; return SYNCANY; }
{VSTRING}/{SPACEOL}*":="                {
                                           BEGIN FCALL;
                                           strcpy(yylval.string, yytext);
                                           return VSTRING;
                                        }
.|\n                                    {  fprintf(cltFP, "%s", yytext); }
%%

int
yywrap()
{
    return 1;
}

void
eatUpComment(void)
{
    int c;

    fprintf(cltFP, "/*");

    for ( ; ; )
    {
        while ( (c = yyinput()) != '*' && c != EOF )
        {
            fputc(c, cltFP);
        	if (c == '\n') lineNo++;
        }
        fputc(c, cltFP);
        if (c == '*')
        {
             while ((c = yyinput()) == '*')
             {
                fputc(c, cltFP);
             }
             fputc(c, cltFP);
        	 if (c == '\n') lineNo++;
             if (c == '/') break;
        }
        if (c == EOF)
        {
              error("EOF in comment");
              break;
        }
    }
}
