%{

#include <stdio.h>
#include "extGlobal.h"
#include "extFuncDefn.h"

extern int   lineNo;
extern int   yylex();
yyerror(char* );

//#define YYDEBUG 1 Commented by Aruna

%}

%union
{
    char   string[5024];
}

%token    SYNC SYNCAND SYNCOR SYNCALL SYNCANY STRING EQ VSTRING
%token    DSTRING

%%

program : element program
        |
        ;

element : rib
        | normal
        | syncDecl
        ;

rib     : SYNC STRING { openServerFile($<string>2); } params ':'
          STRING { writeFuncDefn($<string>2, $<string>4, $<string>6); }
          body   { writeOtherFunc($<string>2, $<string>4, $<string>6); }
        ;

params  : '(' varList ')'  { sprintf($<string>$, "%s", $<string>2); }
        | '(' ')'          { sprintf($<string>$, "");               }
        ;

varList : pair ',' varList    { sprintf($<string>$, "%s, %s",
                                          $<string>1, $<string>3); }
        | pair                { strcpy($<string>$, $<string>1);    }
        ;

pair    : STRING STRING       { sprintf($<string>$, "%s %s",
                                         $<string>1, $<string>2);  }
        ;

body    : '{' '}'
        ;

normal  : arcFuncCall
        | waitOnSync
        ;

waitOnSync  : SYNC '(' syncPair ')' ';' {
                                        processSync($<string>3);
                                      }
            | SYNCAND '(' syncVarList ')' ';' {
                                        processSyncAnd($<string>3);
                                      }
            | SYNCOR  '(' syncVarList ')' ';' {
                                        processSyncOr($<string>3);
                                      }
            | SYNCALL '(' ')' ';'  { processSyncAll(); }
            | SYNCANY '(' ')' ';'  { processSyncAny(); }
            ;

syncVarList : syncPair ',' syncVarList {
                 sprintf($<string>$, "%s %s", $<string>1, $<string>3);
              }
            | syncPair   { strcpy($<string>$, $<string>1); }
            ;

syncPair    : arg ',' '&' arg   {
                 sprintf($<string>$, "%s &%s", $<string>1, $<string>4);
              }
            | arg ',' arg    {
                 sprintf($<string>$, "%s %s", $<string>1, $<string>3);
              }
            ;

arcFuncCall : VSTRING EQ funcCall  {
                        processArcFuncCall($<string>1, $<string>3);
                      }
            ;

funcCall : STRING '(' argList ')' ';' { sprintf($<string>$, "%s %s",
                                    $<string>1, $<string>3);         }
         | STRING '(' ')' ';'      { strcpy($<string>$, $<string>1); }
         ;

argList  : arg ',' argList   { sprintf($<string>$, "%s %s",
                                     $<string>1, $<string>3); }
         | arg               { strcpy($<string>$, $<string>1); }
         ;

arg      : VSTRING         { strcpy($<string>$, $<string>1); }
         | STRING          { strcpy($<string>$, $<string>1); }
         ;

syncDecl : SYNC vars ';' { fprintf(cltFP, "SYNC %s;", $<string>2);}
                            
         ;

vars     : varg ',' vars { sprintf($<string>$, "%s, %s",
                                           $<string>1, $<string>3); }
         | varg          { strcpy($<string>$, $<string>1);  }
         ;

varg     : stars arg     {
                           sprintf($<string>$, "%s%s",
                                               $<string>1, $<string>2);
                           saveSyncVar($<string>2);
                         }
         | arg           {
                           strcpy($<string>$, $<string>1);
                           saveSyncVar($<string>1);
                         }
         ;

stars    : '*' stars     { sprintf($<string>$, "*%s", $<string>2); }
         | '*'           { strcpy($<string>$, "*");  }
         ;

%%

yyerror(char* s)
{
    fprintf(stderr, "%s: %s: parse error near line : %d\n",
                         progName, fileName, lineNo);
    exit(1);
}
