#include <string.h>
#include <stdio.h>
#include "newString.h"

String::String()
{
	_ptr = NULL;
	_length = 0; 
}

String::String(char* str)
{
	_length = strlen(str);
	_ptr = new char[_length + 1];
 	 strcpy(_ptr,str);
}

String::String(String& str)
{
	_length = str.GetLength();
	_ptr = new char[_length + 1];
	 strcpy(_ptr,str.GetString());
}

String::Destroy()
{
     if ( _ptr )
	    delete [] _ptr;
	_length = 0;
}

String::~String()
{
	Destroy();
}

String&
String::operator=(String str)
{
	if (this->_length) this->Destroy();
   _length = str.GetLength();
   _ptr = new char[_length + 1];
	strcpy(_ptr,str.GetString());
}

String&
String::operator=(char *str)
{
	if (this->_length) this->Destroy();
   _length = strlen(str);
   _ptr = new char[_length + 1];
	strcpy(_ptr,str);
}

int
String::GetLength()
{
	return _length;
}

char*
String::GetString()
{
	return _ptr;
}

char
String::operator[](int i)
{
	if (_length <= i)
	{
		 fprintf(stderr,"ERROR : operator[], exiting out.\n");
		 exit(0);
	}
	return _ptr[i];
}
