#include <rpc/rpc.h>            
#include <unistd.h>            
#include "signal.h"
#include <sys/ipc.h>
#include <sys/msg.h>
#include <time.h>
#include <stdarg.h>
#include "Coordinator.h"
#include "defn.h"
#include "msgq.h"

#define  MAXRIBS    100

typedef enum {
    Available,
    NotAvailable,
    Terminated    
} ResultStatus;

typedef struct {
    char*          Arguments;     
    char*          Results;    
    char           Directives[50];
    ResultStatus   Status; 
    int            Timeout;
    int            Retries;
    int            LocalExec;
    int            LockId;
    int            FuncType; 
    char           FuncName[30];
    time_t         StartTime;
    int            RetriesMade;
    u_long         ProgNum;
	int            NodeId;
	char*         NodeName;
} RibData;

typedef struct{
    int            RibId;
	int 		   NodeId;
	char*          NodeName;
	int            Status;
} ResultData;

typedef struct{
	int            ProgNum;
	int 		   RibId;
	int            Status;
	int            NodeId;
	char           NodeName;
} ResultCheck; 

typedef struct {
    int     RibId;
} SYNC;
