#include <sys/time.h>
#include <string.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/resource.h>

#ifdef SPARC
#include <sys/rusage.h>
#endif

#include "mytime.h"

void
my_process_time (int pass, double *user, double *real, double *sys)
{
    static struct rusage ru1;
    static struct rusage ru2;

    static struct timeval tp1;
    static struct timeval tp2;

    static struct timezone tzp1, tzp2;

    double real1;
    double real2;
    double real_diff;
    double systime1;
    double systime2;
    double utime1;
    double utime2;
    double sysdiff;
    double udiff;

    int    i;
    static int Sat = 0;

	switch (pass)
    {
	    case 1 : getrusage ( RUSAGE_SELF, &ru1 );
#ifdef SPARC
		         i = gettimeofday(&tp1);
#else
		         i = gettimeofday(&tp1, &tzp1);
#endif
		         break;

	    case 2 : getrusage ( RUSAGE_SELF, &ru2 ); 
#ifdef SPARC
		         i = gettimeofday(&tp2);
#else
		         i = gettimeofday(&tp2, &tzp2);
#endif
		         break;

	    case 3 :

#ifdef SPARC                    /* on sparc, nano secs are reported */
#define tv_usec tv_nsec         /* instead of micro seconds         */
#endif			

	systime1 = ru1.ru_stime.tv_sec + (0.000001 * ru1.ru_stime.tv_usec);
	systime2 = ru2.ru_stime.tv_sec + (0.000001 * ru2.ru_stime.tv_usec);
	utime1   = ru1.ru_utime.tv_sec + (0.000001 * ru1.ru_utime.tv_usec);
	utime2   = ru2.ru_utime.tv_sec + (0.000001 * ru2.ru_utime.tv_usec);

	printf ("***systime: %lf    usertime:%lf total: %lf\n",
	systime2-systime1,utime2-utime1, systime2-systime1+utime2-utime1); 

#ifdef SPARC                    /* now again nsec should be reset  */
#define tv_nsec tv_usec         /* to usec for timeval             */
#endif

		real1 = tp1.tv_sec + (0.000001 * tp1.tv_usec);
		real2 = tp2.tv_sec + (0.000001 * tp2.tv_usec);
		real_diff = (real2-real1);

		if (user != NULL) *user	= utime2-utime1;
		if (real !=NULL)  *real = real_diff;
		if (sys !=NULL)  *sys 	= systime2-systime1; 

	        printf ("\n****real time = %lf seconds\n",*real);

		break;
	}
}
