#include <stdio.h>
#include <rpc/rpc.h>
#include <unistd.h>
#include <sys/param.h>
#include "../commonIncludes/_defn.h"
#include "../commonIncludes/Coordinator.h"

/*
 */

int main(int argc, char* argv[]) {
	 CLIENT           *cl;
	 char             server[MAXHOSTNAMELEN];
	 int              numOfLocks;  
	 void*            dum;
	 static struct timeval TIMEOUT = {25,0};

	 // if machine name is given on command line use it. Otherwise get
	 // the name of machine on which it is run and use it
	 if (argc == 3) {
		  strcpy(server,argv[2]);
		  numOfLocks  = atoi(argv[1]); 
	 }
	 else if (argc == 2) {
		  //numOfLocks = DEFAULT_NUMBER_OF_LOCKS;
		  numOfLocks  = atoi(argv[1]);
		  //Get the name of the local host
		  if (gethostname(server, MAXHOSTNAMELEN)) {
			   error("depositLock: gethostname(): couldn't get the name of host");
			   error("depositLock: Sorry can't boot up");
			   return GET_HOST_NAME_FAIL;
		  }
	 }
	 else {
		  printf("Usage is : deposit <num_of_locks> [machine_name] \n");
		  printf("Local host is assumed if the machine_name is not specified.\n");
		  exit(0);
	 }

	 if ((cl = clnt_create(server, COORDINATOR, ADMINISTRATION, "tcp"))
			   == NULL) {
		  clnt_pcreateerror(server);
		  return CLIENT_CONNECTION_FAIL;
	 }

	 //deposit_locks_6(&numOfLocks, cl);
	 //Deposit numOfLocks locks with the coordinator.
	 if(clnt_call(cl,DEPOSIT_LOCKS,xdr_int,&numOfLocks,
					xdr_void,NULL,TIMEOUT) != RPC_SUCCESS) {
		  printf("Deposit lock process : The process of depositing the lock has FAILED");
		  clnt_perror(cl,server);
		  exit(CLIENT_CONNECTION_FAIL);
	 }
	 clnt_destroy(cl);
}
