#include <stdio.h>
#include <rpc/rpc.h>
#include <unistd.h>
#include <sys/param.h>
#include "../commonIncludes/_defn.h"
#include "../commonIncludes/Coordinator.h"

/*
    Boot strapping will initialize the data which is global for
    remote procedures.

    This is the client program which will call the server at this
    node itself.
*/

int main(int argc, char* argv[]) {
     CLIENT           *cl;
     char             server[MAXHOSTNAMELEN];
     int              numOfLocks;  
     void*            dum;
     LocalLockArr*    lockList;

     if (gethostname(server, MAXHOSTNAMELEN))
     {
        error("main: gethostname: couldn't get the name of host");
        error("main: Sorry can't boot up");
        return GET_HOST_NAME_FAIL;
     }

     if (argc == 1)
     {
         numOfLocks = DEFAULT_NUMBER_OF_LOCKS;
     }
     else
     {
         numOfLocks  = atoi(argv[1]);
     }

     if ((cl = clnt_create(server, COORDINATOR, USER_INTERACTION, "tcp"))
                                            == NULL)
     {
        clnt_pcreateerror(server);
        return CLIENT_CONNECTION_FAIL;
     }

     lockList = get_locks_available_5(&numOfLocks, cl);
     clnt_destroy(cl);
}
